pynbody
=======

[Pynbody](https://github.com/pynbody/pynbody) is a light-weight,
portable, format-transparent analysis framework for N-body and
hydrodynamic astrophysical simulations supporting PKDGRAV/Gasoline,
Gadget, N-Chilada, and RAMSES AMR outputs. 

Written in python, the core tools are accompanied by a library of
publication-level analysis routines. For a quick tour of some of 
the features, have a look at this [IPython notebook](http://nbviewer.ipython.org/github/pynbody/pynbody/blob/master/examples/notebooks/pynbody_demo.ipynb).

### Getting started 

If your python with distutils is installed and properly configured, you can simply do:

```
$ git clone https://github.com/pynbody/pynbody
$ cd pynbody
$ python setup.py install
$ cd ..
$ python
>>> import pynbody
```

If this fails, you may need some more detailed [installation
instructions](http://pynbody.github.io/pynbody/installation.html). Once
you have the package instlaled, try the introductory
[tutorials](http://pynbody.github.io/pynbody/tutorials/tutorials.html).
The full documentation can be found
[here](http://pynbody.github.io/pynbody/).

### Support and Contact 

If you have trouble with Pynbody or you have feature
requests/suggestions you can [submit an issue](https://github.com/pynbody/pynbody/issues), 
and/or shoot us an email on the [Usergroup mailing
list](https://groups.google.com/forum/?fromgroups#!forum/pynbody-users).
